#include <iostream>
#include <list>
#include <algorithm>
using namespace std;

#ifdef ALTES_DISTANCE
#include "distance.h"
#endif

int main()
{
    list<int> liste;

    /* Elemente 1 bis 9 doppelt in die Liste einfuegen
     */
    for (int i=1; i<=9; i++) {
        liste.push_back(i);
        liste.push_back(i);
    }

    /* Liste ausgeben
     */
    copy (liste.begin(), liste.end(),
          ostream_iterator<int>(cout," "));
    cout << endl;

    /* erste und letzte Position, an der 5 eingefuegt werden koennte,
     * ausgeben
     */
    list<int>::iterator pos1, pos2;

    pos1 = lower_bound (liste.begin(), liste.end(), 5);
    pos2 = upper_bound (liste.begin(), liste.end(), 5);

    cout << "5 kann " << distance(liste.begin(),pos1) + 1
         << ". bis "  << distance(liste.begin(),pos2) +1
         << ". Element werden" << endl;

    /* 3 an der ersten passenden Position einfuegen, ohne die
     * Sortierung zu zerstoeren
     */
    liste.insert (lower_bound(liste.begin(),liste.end(),3), 3);

    /* 7 an der letzten passenden Position einfuegen, ohne die
     * Sortierung zu zerstoeren
     */
    liste.insert (upper_bound(liste.begin(),liste.end(),7), 7);

    /* Liste wieder ausgeben
     */
    copy (liste.begin(), liste.end(),
          ostream_iterator<int>(cout," "));
    cout << endl;
}
