#include <iostream>
#include <set>
#include <algorithm>
#include <iterator>
using namespace std;

int main()
{
    set<int> menge;

    /* Elemente 1 bis 9 in die Menge einfuegen
     */
    for (int i=1; i<=9; i++) {
        menge.insert(i);
    }

    /* Menge ausgeben
     */
    copy (menge.begin(), menge.end(),
          ostream_iterator<int>(cout," "));
    cout << endl;

    /* Menge einmal nach links rotiert ausgeben
     */
    set<int>::iterator pos;
    pos = menge.begin();
    advance (pos, 1);
    rotate_copy (menge.begin(), pos, menge.end(),
                 ostream_iterator<int>(cout," "));
    cout << endl;

    /* Menge zweimal nach rechts rotiert ausgeben
     */
    pos = menge.end();
    advance (pos, -2);
    rotate_copy (menge.begin(), pos, menge.end(),
                 ostream_iterator<int>(cout," "));
    cout << endl;
}
