#include <cstdio>
#include <streambuf>
using namespace std;

class outbuf : public streambuf {
  protected:
    /* zentrale Ausgabefunktion
     *  - Zeichen (als Grossbuchstabe) ausgeben
     */
    virtual int_type overflow (int_type c) {
        if (c != EOF) {
            // Kleinbuchstaben in Grossbuchstaben umwandeln
            //c = toupper (c, getloc());
            c = toupper (c);

            // und Zeichen ausgeben
            if (putchar(c) == EOF) {
                return EOF;
            }
        }
        return c;
    }
};
