#include <iostream>
#include <set>
#include <list>
#include <algorithm>
using namespace std;

void print (int elem)
{
    cout << elem << ' ';
}

int main()
{
    set<int, less<int> > menge;

    /* Insert-Iterator fuer menge erzeugen
     */
    insert_iterator<set<int,less<int> > > iter(menge,menge.begin());

    /* Elemente darueber einfuegen
     */
    iter = 1;
    iter = 2;
    iter = 3;

    /* Elemente ausgeben
     */
    for_each (menge.begin(), menge.end(),    // Bereich
              print);                        // Operation
    cout << endl;

    /* Insert-Iterator als Inserter erzeugen
     */
    inserter(menge,menge.end()) = 55;

    /* Elemente ausgeben
     */
    for_each (menge.begin(), menge.end(),    // Bereich
              print);                        // Operation
    cout << endl;

    /* copy() mit Inserter zum Einfuegen in leere Liste
     */
    list<int> liste;
    copy (menge.begin(), menge.end(),        // Quellbereich
          inserter(liste,liste.begin()));    // Zielbereich

    /* copy() mit Inserter zum Einfuegen vorm zweiten Element
     */
    copy (menge.begin(), menge.end(),        // Quellbereich
          inserter(liste,++liste.begin()));  // Zielbereich

    /* Elemente ausgeben
     */
    for_each (liste.begin(), liste.end(),    // Bereich
              print);                        // Operation
    cout << endl;
}
