#include <iostream>
#include <vector>
#include <algorithm>
#include <functional>
#include "PRINT.h"
using namespace std;

bool istGerade (int elem)
{
    return elem % 2 == 0;
}

int main()
{
    vector<int> menge;
    int anzahl;

    /* Elemente 1 bis 7 in die Menge einfuegen
     */
    for (int i=1; i<=7; i++) {
        menge.push_back(i);
    }
    PRINT ("menge: ", menge);

    /* Anzahl der Elemente mit Wert 4 ausgeben
     */
    anzahl = 0;
    count (menge.begin(), menge.end(),
           4, anzahl);
    cout << "Anzahl der Elemente mit Wert 4: " << anzahl << endl;

    /* Anzahl der geraden Elemente ausgeben
     */
    anzahl = 0;
    count_if (menge.begin(), menge.end(),
              istGerade, anzahl);
    cout << "Anzahl der geraden Elemente: " << anzahl << endl;

    /* Anzahl der Elemente, die groesser als 4 sind,
     *  aufaddieren und ausgeben
     */
    count_if (menge.begin(), menge.end(),
              bind2nd(greater<int>(),4), anzahl);
    cout << "plus Anzahl der Elemente > 4: " << anzahl << endl;
}
