#include <iostream>
#include <list>
#include <algorithm>
#include <functional>
#include "PRINT.h"
using namespace std;

int main()
{
    // Ausgangsdaten
    int daten [16] = { 1, 4, 4, 6, 1, 2, 2, 3, 6, 6, 6, 5, 7, 5, 4, 4};

    list<int> menge;

    /* Ausgangsdaten in die Menge kopieren
     */
    copy (daten, daten+16, back_inserter(menge));

    PRINT ("", menge);

    /* aufeinanderfolgende Duplikate entfernen
     */
    list<int>::iterator ende;
    ende = unique (menge.begin(), menge.end());

    /* Menge ausgeben
     *  - BEACHTE: menge.end() liefert das ALTE Ende
     */
    copy (menge.begin(), menge.end(),
          ostream_iterator<int>(cout," "));
    cout << endl;

    /* Menge mit neuem Ende ausgeben
     */
    copy (menge.begin(), ende,
          ostream_iterator<int>(cout," "));
    cout << "\n\n";


    /* Ausgangsdaten nochmal in die Menge kopieren
     */
    copy (daten, daten+12, menge.begin());

    PRINT ("menge: ", menge);

    /* jeweils nachfolgende kleinere Werte entfernen
     * und Groesse entsprechend anpassen
     */
    menge.erase (unique (menge.begin(), menge.end(),
                         greater<int>()),
                 menge.end());

    PRINT ("menge: ", menge);
}
