#include <iostream>
#include <vector>
#include <list>
#include <deque>
#include <set>
#include <algorithm>
using namespace std;

int main()
{
    list<int>   menge1;

    /* Elemente 1 bis 9 in die erste Menge einfuegen
     */
    for (int i=1; i<=9; i++) {
        menge1.push_back(i);
    }

    /* Elemente in die zweite Menge hinten einfuegend kopieren
     */
    vector<int> menge2;
    copy (menge1.begin(), menge1.end(),     // Quellbereich
          back_inserter(menge2));           // Zielbereich

    /* Elemente in die dritte Menge vorne einfuegend kopieren
     */
    deque<int> menge3;
    copy (menge1.begin(), menge1.end(),     // Quellbereich
          front_inserter(menge3));          // Zielbereich

    /* Elemente in eine assoziative Menge einfuegen
     */
#ifdef __GNUC__
    set<int,less<int> > menge4;
#else
    set<int> menge4;
#endif
    copy (menge1.begin(), menge1.end(),     // Quellbereich
          inserter(menge4,menge4.begin())); // Zielbereich
}
