#include <iostream>
#include <string>
using namespace std;

int main (int argc, char** argv)
{
    const string trenner(" \t,.;");
    string zeile;

    /* fuer jede erfolgreich gelesene Zeile
     */
    while (getline(cin,zeile)) {
        string::size_type anf, end;

        /* jeweils Anfang und Ende eines Wortes suchen
         *  - Trennzeichen sind alle Zeichen in "trenner"
         */

        // erster Anfang
        anf = zeile.find_first_not_of(trenner);

        // solange Wort-Anfang gefunden
        while (anf != string::npos) {
            // Ende zum Anfang
            end = zeile.find_first_of (trenner, anf);

            // ggf. Zeilenende nehmen
            if (end == string::npos) {
                end = zeile.length();
            }

            // Wort rueckwaerts ausgeben
            for (int i=end-1; i>=(int)anf; i--) {
                cout << zeile[i];
            }
            cout << endl;

            // naechster Anfang
            anf = zeile.find_first_not_of (trenner, end);
        }
    }
}
